<?php
/**
 * SOTESHOP/stUpdate
 *
 * This file is the part of stUpdate application. License: (Open License SOTE) Open License SOTE.
 * Do not modify this file, system will overwrite it during upgrade.
 *
 * @package     stUpdate
 * @subpackage  libs
 * @copyright   SOTE (www.sote.pl)
 * @license     http://www.sote.pl/license/open (Open License SOTE) Open License SOTE
 * @version     $Id: stStepsSetup.class.php 8768 2010-10-13 12:43:27Z piotr $
 */

/**
 * Setup
 *
 * @package     stUpdate
 * @subpackage  libs
 */
class stStepsSetup extends stStepsInstaller {

	public function close() {

		parent::close();

		sfLoader::loadHelpers('Tag');
		sfLoader::loadHelpers('Javascript');

		$this->msg.="<script type=\"text/javascript\">document.getElementById('stSetup-download_actions').style.visibility=\"visible\";</script>";

	}


    public function getTitle()
    {
        $i18n = sfContext::getInstance()->getI18N();
        return $i18n->__('Pobieranie aplikacji', null, 'stInstallerWeb').': ';
    }

    public function getFatalMessage()
    {
    	sfLoader::loadHelpers('Tag');
    	sfLoader::loadHelpers('I18N');
    	sfLoader::loadHelpers('Url');
    	
    	return __("Wystąpił błąd podczas pobierania oprogramowania SOTESHOP 5.0, większość problemów można rozwiązać korzystając z").
    		' <strong>'.link_to(__('Podręcznika instalacji'), __('http://www.sote.pl/trac/wiki/doc/soteshop_installation'),array('target'=>'_blank')).'</strong>';
    }
    
}

?>