<?php
/** 
 * SOTESHOP/stUpdate 
 * 
 * This file is the part of stUpdate application. License: (Open License SOTE) Open License SOTE. 
 * Do not modify this file, system will overwrite it during upgrade.
 * 
 * @package     stUpdate
 * @subpackage  libs
 * @copyright   SOTE (www.sote.pl)
 * @license     http://www.sote.pl/license/open (Open License SOTE) Open License SOTE
 * @version     $Id: stCheckRequirements.class.php 3183 2010-01-27 14:01:12Z marek $
 * @author Piotr Halas piotr.halas@sote.pl
 */

/** 
 * PHP verification.
 * 
 * @author Piotr Halas piotr.halas@sote.pl
 * @package     stUpdate
 * @subpackage  libs
 */
class stCheckRequirements {

    /** 
     * Execute all system tests.
     *
     * @return   boolean true - all tests passed, false - one or more tests failed
     */
	public static function test() {
		if (!self::testCurl()) return false;
		if (!self::testSuPHP()) return false;
		if (!self::testSafeMode()) return false;
		if (!self::testJsonEncode()) return false;
		return true;
	}

    /** 
    * Check if suphp is enabled.
    *
    * @return   boolean
    */
	public static function testSuPHP() {
        $filename = sfConfig::get('sf_cache_dir').DIRECTORY_SEPARATOR.'file.test';
        touch($filename);
        $apache_uid = fileowner($filename);
        $index_uid = fileowner(sfConfig::get('sf_web_dir').DIRECTORY_SEPARATOR.'index.php'); 
        unlink($filename);
        
        if ($apache_uid != $index_uid) return false;
        
		return true;
	}


    /** 
    * Check cUrl.
    *
    * @return   boolean
    */
	public static function testCurl() {
		return function_exists('curl_init');
	}

    /** 
    * Check if safe_mode is off,
    *
    * @return   boolean
    */
	public static function testSafeMode() {
        return !ini_get('safe_mode');
	}

    /**
     * Check Json.
     */
	public static function testJsonEncode() {
		return function_exists('json_encode');
	}
	
}