<?php
/** 
 * SOTESHOP/stUpdate 
 * 
 * This file is the part of stUpdate application. License: (Open License SOTE) Open License SOTE. 
 * Do not modify this file, system will overwrite it during upgrade.
 * 
 * @package     stUpdate
 * @subpackage  libs
 * @copyright   SOTE (www.sote.pl)
 * @license     http://www.sote.pl/license/open (Open License SOTE) Open License SOTE
 * @version     $Id: stAppVerifyall.class.php 4396 2010-04-04 13:02:41Z marek $
 * @author      Marek Jakubowicz <marek.jakubowicz@sote.pl>
 */
                

/** 
 * stAppVerify class
 *
 * @package     stUpdate
 * @subpackage  libs
 */
require_once (sfConfig::get('sf_app_dir').DIRECTORY_SEPARATOR.'lib'.DIRECTORY_SEPARATOR.'stAppVerify.class.php'); 
      
/** 
 * Code verification for all packages.
 *
 * @package     stUpdate
 * @subpackage  libs
 */
class stAppVerifyall extends stAppVerify 
{
    protected function getApps()
    {
        $peari = stPearInfo::getInstance();
        $packages = $peari->getPackages();
        $i=0;
        foreach ($packages as $package=>$data)
        {        
            $apps[]=$package;
            $i++;                
        } 
        
        return $apps;
    }           
                       
    /** 
     * Reboot action
     *
     * @return   string
     */
    protected function reboot()
    {
         return __('Aplikacje zostały poprawnie zweryfikowane. Nie ma modyfikacji plików systemowych.'); 
    }          
                                 
    /** 
     * Get number of installed applications.
     */
    static public function getCount()
    {
        $peari = stPearInfo::getInstance();
        $packages = $peari->getPackages();
        return sizeof($packages);
    }
    
    /**
     * Skip PEAR install/src verification
     */
    public function verifyPearInstall()
    {
        return NULL; 
    }
}                              
