<?php
/**
 * SOTESHOP  5.0.1
 * 
 * Ten plik należy do aplikacji SOTESHOP opartej na licencji (Professional License SOTE). 
 * Nie zmieniaj tego pliku, jeśli chcesz korzystać z automatycznych aktualizacji oprogramowania. 
 * Jeśli chcesz wprowadzać swoje modyfikacje do programu, zapoznaj się z dokumentacją, jak zmieniać 
 * oprogramowanie bez zmiany kodu bazowego http://www.sote.pl/modifications
 * 
 * @package     SOTESHOP
 * @copyright   SOTE (www.sote.pl)
 * @license     http://www.sote.pl/license/sote (Professional License SOTE)
 * @version     $Id: stSoteshopInstallerCli_win32.php 41 2009-08-24 14:51:53Z marek $
 * @author      Piotr Hałas <piotr.halas@sote.pl>      
 * @since       stInstallerPlugin 1.0.3
 */                         
      
/**                 
 * Instalator SOTESHOP
 * 
 * @package SOTESHOP
 */
class stSoteshopInstallerCliWin32 extends stSoteshopInstallerCli
{   

    protected function systemSettings() {
    }    
    
    /**
     * Pomoc dla komendy instalatora.
     * 
     * @return string 
     */                
     protected function help()
     {   
         $argv=$_SERVER['argv'];  
         $help="\n";  
         $help.="Try php ".$argv[0]." [option=value]\n";
         $help.="\n";
         $help.="Example:\n";
         $help.="  php ".$argv[0]." \"application=pear.sote.pl/soteshop\" \"database=username:password@localhost/dbname\" \"auth=admin@example.com:password\"\n";                     
         $help.="\n";
         return $help;
     }           
        
    /**
     * Weryfikuje wersję Symfony
     */
    protected function checkSymfony()
    {   
        $include_path=ini_get('include_path');
        $paths=split(';',$include_path);
        foreach ($paths as $path)
        {                   
            $file=$path.DIRECTORY_SEPARATOR.'symfony'.DIRECTORY_SEPARATOR.'VERSION';
            print $file."\n";
            if (file_exists($file))
            {
                $symfony_version_file=$file;
            }
        }                                   
        
        if (empty($symfony_version_file))  die('The symfony not found in PEAR repository.'."\n");
        
        $fd=fopen($symfony_version_file,'r');$raw_version=fread($fd,filesize($symfony_version_file));fclose($fd);
        $version=trim($raw_version);        
        $this->checkVersion($version,ST_SYMFONY_MIN,ST_SYMFONY_MAX,'symfony');
        
        $symfony=exec('symfony -V');
        if (! eregi('version',$symfony)) die ("Check symfony installation.\n");
        $this->log("Symfony: ... OK");
    }  
        
    /**
     * Zwraca komendę symfony dla systemu operacyjnego.
     *
     * @param strng $mode local|global lokal - oznacza lokalny plik instalacji symfony, global - plik z repozytortium PEAR 
     */                                                    
    protected function symfony($mode='local',$cache='')
    {                                            
        if ($cache=='cache') $symfony=$this->php().'-n symfony.php'; else $symfony='symfony';
        return "$symfony ";
    }                
        
    /**
     * Zwaraca ścieżkę do php.
     */                       
     protected function php()
     {
         return 'php';
     }            
         
     /**
      * Konfiguruje PEAR.
      */                  
     protected function initPEAR()
     {            
         $this->log("PEAR setup:");       
         $ROOTDIR=SF_ROOT_DIR;                          
         $peardir=$ROOTDIR.DIRECTORY_SEPARATOR.'install'.DIRECTORY_SEPARATOR.'src';              
         $pearfile='.pearrc';                             
         $pearrc=$peardir.DIRECTORY_SEPARATOR.$pearfile;                                
         
         $pearrc_plugins=$ROOTDIR.DIRECTORY_SEPARATOR.'plugins'.DIRECTORY_SEPARATOR.'.pearrc';
         
         $execs=array(                    
             $this->symfony().' plugin-list',               
             $this->pear()." -c $pearrc_plugins config-set  temp_dir    $ROOTDIR".DIRECTORY_SEPARATOR."cache",
                          
             'pear -c plugins\.pearrc channel-discover '.$this->pear,
             'cd plugins & pear -c .pearrc channel-discover '.$this->pear.' & cd ..',
             'cd install'.DIRECTORY_SEPARATOR.'src & pear config-create '.$peardir.' '.$pearfile,       
 
             $this->pear()." -c $pearrc config-set php_dir      $ROOTDIR/install/src",
             $this->pear()." -c $pearrc config-set bin_dir      $ROOTDIR/install/src",
             $this->pear()." -c $pearrc config-set doc_dir      $ROOTDIR/install/src",
             $this->pear()." -c $pearrc config-set data_dir     $ROOTDIR/install/src",
             $this->pear()." -c $pearrc config-set ext_dir      $ROOTDIR/install/src",
             $this->pear()." -c $pearrc config-set test_dir     $ROOTDIR/install/src",
             $this->pear()." -c $pearrc config-set cfg_dir      $ROOTDIR/install/src",
             $this->pear()." -c $pearrc config-set www_dir      $ROOTDIR/install/src",
             $this->pear()." -c $pearrc config-set temp_dir     $ROOTDIR/install/cache",
             $this->pear()." -c $pearrc config-set cache_dir    $ROOTDIR/install/cache",
             $this->pear()." -c $pearrc config-set download_dir $ROOTDIR/install/download",                                                                        
             $this->pear()." -c $pearrc config-set cache_ttl        3600",
             $this->pear()." -c $pearrc config-set php_bin      ".$this->php(),     
             $this->pear()." -c $pearrc config-set preferred_state  stable",
             $this->pear()." -c $pearrc config-set umask            022",                         
             );    
             
         foreach ($execs as $exec)
         {           
             $exec=str_replace('/install/',DIRECTORY_SEPARATOR.'install'.DIRECTORY_SEPARATOR,$exec);
             $this->exec($exec);
         }   
        
         // zainstaluj instalator SOTESHOP
         $this->installStInstallerPlugin();       
         $this->exec($this->symfony().' cc');
                            
         $this->exec($this->symfony().' pear channel-discover '.$this->pear);
         $this->exec($this->symfony().' pear config-set default_channel '.$this->pear);
                           
     }

     /**
      * Sync hronizuje aplikacje SOTESHOP
      */
     public function syncReboot() 
     {                                            
        $this->exec($this->symfony().' sync-reboot "'.$this->database.'"');        
     }     
}      


         
